From 0fb137235dd0fcb311343afaf11c1d694df90315 Mon Sep 17 00:00:00 2001
From: Juan Jose Garcia Ripoll <jjgarcia@jjgr-2.local>
Date: Sat, 17 Apr 2010 23:04:58 +0200
Subject: [PATCH] Allow DEFSYSTEM forms to have prerequisites themselves.

---
 asdf.lisp |    6 ++++--
 1 files changed, 4 insertions(+), 2 deletions(-)

diff --git a/asdf.lisp b/asdf.lisp
index a8911c8..8d96abb 100644
--- a/asdf.lisp
+++ b/asdf.lisp
@@ -1898,13 +1898,15 @@ details."
 
 (defmacro defsystem (name &body options)
   (destructuring-bind (&key (pathname nil pathname-arg-p) (class 'system)
-                            &allow-other-keys)
+                            asdf-dependencies &allow-other-keys)
       options
-    (let ((component-options (remove-keyword :class options)))
+    (let ((component-options (remove-keys '(:asdf-dependencies :class) options)))
       `(progn
          ;; system must be registered before we parse the body, otherwise
          ;; we recur when trying to find an existing system of the same name
          ;; to reuse options (e.g. pathname) from
+         ,@(loop for system in asdf-dependencies
+              collect `(asdf:oos 'asdf:load-op ,system))
          (let ((s (system-registered-p ',name)))
            (cond ((and s (eq (type-of (cdr s)) ',class))
                   (setf (car s) (get-universal-time)))
-- 
1.6.6.1

